[changes]
* RTF export: JPEG images are supported.
* Formula fields are now allowed to return array and range values. If an array result is used in the report, only the first element will be shown.
* The formula function ToText now supports to convert ranges of any type to a readable form. For date, time, dateTime and number ranges a pattern can be specified as well. 
* It is now supported to use Joins between BeanDataSources. The data fetching includes now the data of all sub objects of bean which are not of Java primitive type, see the property "Data fetching depth in sub beans" of bean datasource.
* i-net Crystal-Clear now supports "fixed" currency symbols. The currency symbol is then aligned to the side of the element while the value can be aligned on its own. i-net Crystal-Clear now supports the option "one currency symbol per page". This will cause the currency symbol to only be printed once per page rather than for each record.
* PDF export: JPEG images and some types of PNG images that are not modified through scale or crop operations are written in PDF file without conversion to the default PDF image format. This reduces the size of the created PDF file.
* DatabaseBean now reads only the used columns.
* RTF export: To reduce the memory usage and file size, static images are now written in PNG or JPEG format instead of using enhanced Windows metafile format.
* The formula statements SELECT and cascading IF(Basic Syntax) can now be optimized which makes them executable on the database in some cases.
* The before reading formula will be executed now always before the record selection formula.
* HTML error messages are UTF8 encoded for localized error messages.
* HTML export: Images for that an hyperlink was configured will be displayed without blue border.
* The formula function datetime no longer supports the date pattern MM-dd-yyyy, since it is ambiguous to dd-MM-yyyy.
* FormulaField.getValueType() no longer throws runtime exceptions. The method will return the cached value type or calculate the current one, if required. To re-calculate the value type of a formula field, call validate() on this field.

### i-net Crystal-Clear - Java Viewer
* Using the checkbox "Multiple" and "Select All" it is now possible in the dialog "Enter Prompt Values" to select multiple or all default values for a parameter field that allows multiple values.

### i-net Designer
* Formula Editor: It is now possible to define your own formula functions. These functions can be written in Crystal or Basic syntax and can be used in any formula like build in functions.
* Number Property "One Currency Symbol per Page" supported.
* Database Wizard: A replacement dialog will be displayed in the Database Wizard. It supports you by replacing and moving of tables and stored procedures, editing of commands and by adapting of the reports to the changed database structure after a refresh of the database connection.
* Java Beans
  * Customizer component supported.
  * 2D Barcode JavaBean added.
* When loading a report which uses a Java Bean that is not available in the current designer, a warning is now shown.
* If the designed height of a section is greater than the page height, then the section background will be red and a warning will be shown in the section.
* The formula editor in the i-net Designer now checks constant parts of the formula instantly. This will show for instance division by zero errors already at design time.
* Database Wizard: It is now possible to modify the values of the stored procedure parameters using popup menu item "Change Parameters...".
* The file open dialog now allows to enter absolute or relative paths. Until now the user had to select the folder and type the filename.
* The file name in the file open dialog of the i-net Designer will now be validated during typing.
* SQL expression Field display an error if more than one column is returned. 

### Ad Hoc Reporting

* Ad Hoc reporting now ignores directories with a dot at the beginning of their name (invisible directories on unix/linux).
* The Ad Hoc web GUI now prohibits to overwrite reports with an equal name by default. Overwriting can be enabled by a checkbox.
* It is now possible to set the default rendering format of Ad Hoc reports in the Configuration Manager.

### Configuration Manager
* There are two new command line arguments you can use: -exportconfig <config> <file> exports the specified configuration to the specified file and -listconfigurations displays a list of the installed i-net Crystal-Clear configurations on the server.
* Configuring Permissions: The remote configuration manager in the Remote Interface now also offers a list with already logged in users if the login type is set to Windows authentication.

### Setup
* Glassfish application server is supported.

[changes:de]
* RTF-Export: JPEG-Bilder werden unterstützt.
* Formelfelder können jetzt auch Array- und Bereichswerte zurückgeben. Wenn ein Array-Ergebnis im Bericht verwendet wird, wird nur das erste Element angezeigt.
* Die Formelfunktion ToText unterstützt jetzt die Umwandlung von Bereichen beliebigen Typs in eine lesbare Form. Für Datums-, Zeit-, dateTime- und Zahlenbereiche kann auch ein Muster angegeben werden.
* Es wird nun unterstützt, Joins zwischen BeanDataSources zu verwenden. Der Datenabruf umfasst nun auch die Daten aller Unterobjekte von Beans, die nicht vom Java-Primitiv-Typ sind, siehe die Eigenschaft "Datenabruftiefe in Unterbeans" der BeanDataSource.
* i-net Crystal-Clear unterstützt jetzt "feste" Währungssymbole. Das Währungssymbol wird dann an der Seite des Elements ausgerichtet, während der Wert selbständig ausgerichtet werden kann. i-net Crystal-Clear unterstützt nun die Option "ein Währungssymbol pro Seite". Dies führt dazu, dass das Währungssymbol nur einmal pro Seite und nicht für jeden Datensatz gedruckt wird.
* PDF-Export: JPEG-Bilder und einige Arten von PNG-Bildern, die nicht durch Skalierungs- oder Beschneidungsoperationen verändert werden, werden ohne Konvertierung in das Standard-PDF-Bildformat in eine PDF-Datei geschrieben. Dadurch wird die Größe der erstellten PDF-Datei reduziert.
* DatabaseBean liest jetzt nur noch die verwendeten Spalten.

* RTF-Export: Um den Speicherverbrauch und die Dateigröße zu reduzieren, werden statische Bilder jetzt im PNG- oder JPEG-Format geschrieben, anstatt das erweiterte Windows-Metadateiformat zu verwenden.
* Die Formelanweisungen SELECT und kaskadierende IF(Basic Syntax) können jetzt optimiert werden, was sie in einigen Fällen auf der Datenbank ausführbar macht.
* Die Before-Reading-Formel wird nun immer vor der Record-Selection-Formel ausgeführt.
* HTML-Fehlermeldungen sind für lokalisierte Fehlermeldungen UTF8-kodiert.
* HTML-Export: Bilder, für die ein Hyperlink konfiguriert wurde, werden ohne blauen Rahmen angezeigt.
* Die Formelfunktion datetime unterstützt nicht mehr das Datumsmuster MM-dd-yyyy, da es mehrdeutig zu dd-MM-yyyy ist.
* FormulaField.getValueType() löst keine Laufzeitausnahmen mehr aus. Die Methode gibt den zwischengespeicherten Wertetyp zurück oder berechnet den aktuellen Wertetyp, falls erforderlich. Um den Wertetyp eines Formelfeldes neu zu berechnen, rufen Sie validate() für dieses Feld auf.

### i-net Crystal-Clear - Java Viewer
* Mit den Checkboxen "Mehrere" und "Alles auswählen" ist es nun möglich, im Dialog "Eingabeaufforderung" mehrere oder alle Standardwerte für ein Parameterfeld auszuwählen, das mehrere Werte zulässt.

### i-net Designer
* Formeleditor: Es ist nun möglich, eigene Formelfunktionen zu definieren. Diese Funktionen können in Crystal- oder Basic-Syntax geschrieben werden und können in jeder Formel wie eingebaute Funktionen verwendet werden.
* Zahleneigenschaft "Ein Währungssymbol pro Seite" wird unterstützt.
* Datenbank-Assistent: Ein Ersetzungsdialog wird im Datenbank-Assistenten angezeigt. Er unterstützt Sie beim Ersetzen und Verschieben von Tabellen und Stored Procedures, beim Bearbeiten von Befehlen und beim Anpassen der Berichte an die geänderte Datenbankstruktur nach einer Aktualisierung der Datenbankverbindung.
* Java Beans
  * Customizer Komponente unterstützt.
  * 2D Barcode JavaBean hinzugefügt.

* Beim Laden eines Berichts, der eine Java Bean verwendet, die im aktuellen Designer nicht verfügbar ist, wird nun eine Warnung angezeigt.
* Wenn die entworfene Höhe eines Abschnitts größer als die Seitenhöhe ist, wird der Hintergrund des Abschnitts rot und eine Warnung wird im Abschnitt angezeigt.
* Der Formeleditor im i-net Designer prüft nun konstante Teile der Formel sofort. Dadurch werden z.B. Fehler bei der Division durch Null bereits zur Entwurfszeit angezeigt.
* Datenbank-Assistent: Es ist jetzt möglich, die Werte der Stored-Procedure-Parameter über den Popup-Menüpunkt "Change Parameters..." zu ändern.
* Der Datei-Öffnen-Dialog erlaubt nun die Eingabe von absoluten oder relativen Pfaden. Bisher musste der Benutzer den Ordner auswählen und den Dateinamen eingeben.
* Der Dateiname im Datei-Öffnen-Dialog des i-net Designers wird nun während der Eingabe validiert.
* SQL-Ausdruck Feld zeigt einen Fehler an, wenn mehr als eine Spalte zurückgegeben wird.

### Ad Hoc Reporting

* Das Ad Hoc Reporting ignoriert jetzt Verzeichnisse mit einem Punkt am Anfang des Namens (unsichtbare Verzeichnisse unter Unix/Linux).
* Die Ad Hoc Web-GUI verbietet nun standardmäßig das Überschreiben von Berichten mit gleichem Namen. Das Überschreiben kann durch ein Kontrollkästchen aktiviert werden.
* Es ist nun möglich, das Standard-Rendering-Format von Ad Hoc-Berichten im Konfigurations-Manager einzustellen.

### Konfigurations-Manager
* Es gibt zwei neue Befehlszeilenargumente, die Sie verwenden können: -exportconfig <config> <file> exportiert die angegebene Konfiguration in die angegebene Datei und -listconfigurations zeigt eine Liste der installierten i-net Crystal-Clear Konfigurationen auf dem Server an.
* Konfigurieren von Berechtigungen: Der Remote-Konfigurationsmanager in der Remote-Schnittstelle bietet jetzt auch eine Liste mit bereits angemeldeten Benutzern an, wenn der Anmeldetyp auf Windows-Authentifizierung eingestellt ist.

### Einrichtung
* Glassfish-Anwendungsserver wird unterstützt.

[bugfixes]
* GlassFish servers could experience a NullPointerException when shutting down, this is now handled correctly.
* Report Reader: 
  * Renamed stored procedure prompts in Crystal Reports templates were not correctly converted by the .NET-based Report Reader.
  * The Report Reader tool could show an error if it did not have the rights to log to a file. Even when it doesn't have rights to log, it no longer will show an error.
* A possible deadlock in hard disk and database cache has occurred. In this case, the log output has contained the endless repeated message "wait for unlock in delete".
* Security Bug occurred: With the Header HTTP X-Forward it was possible to bypass the IP filter. Now it is also necessary to specify the address of a proxy.
* Windows authentication has worked with Jetty application server version 7.2 but not with version 7.0.
* Exception "Invalid render state. Page already finished." has occurred for reports that show only a report header and have the "New Page After" property enabled for one of the suppressed sections.
* Exception occurred during reading of column labels (aliases) of a command.
* DatabaseBean has returned incorrect values if the subbeans were null.

### i-net Crystal-Clear - Java Viewer
* There was an issue with the standalone report viewer not correctly updating its cookie from the server which could lead to searching in a report not working correctly.
* Copying text from a report in the report viewer would always have an extra line break at the end. This extra line break has been removed.
* Print dialog ignores PrintService in PrinterJob if SwingReportView.showPrintDialog(Component, PrinterJob, HashPrintRequestAttributeSet) was called.

### i-net Designer
* The SQL editor for queries has been slightly improved, minor quirks have been removed.
* A NullPointerException has occurred, when the number category in the Property Editor was opened for multiple selected field elements with different settings in currency type.
* Commands referencing a prompt with a default value could create an invalid SQL statement while refreshing the columns of the command.
* When editing a report located remotely on a repository, the font box in the chart dialog did not display the fonts available on the server where the report was located but rather those available on the client.
* Database Wizard: "Refresh Connection" has not refreshed the database objects.

### Ad Hoc Reporting
* It was not possible to load a saved Ad Hoc report correctly. It was necessary to select the Ad Hoc data view again.

### Configuration Manager
* Changing the setting "Use Native Fonts" in the i-net Crystal-Clear configuration did not have an effect until the report server was restarted.
* Configured roles of the system permissions haven't been restored correctly. 

[bugfixes:de]
* Bei GlassFish-Servern konnte es beim Herunterfahren zu einer NullPointerException kommen. Dies wird nun korrekt gehandhabt.
* Report Reader:
  * Umbenannte gespeicherte Prozeduraufforderungen in Crystal Reports-Vorlagen wurden vom .NET-basierten Report Reader nicht korrekt konvertiert.
  * Das Report Reader-Tool konnte einen Fehler anzeigen, wenn es nicht über die Rechte zur Protokollierung in einer Datei verfügte. Auch wenn es keine Rechte für die Protokollierung hat, wird kein Fehler mehr angezeigt.
* Ein möglicher Deadlock im Festplatten- und Datenbank-Cache ist aufgetreten. In diesem Fall enthielt die Protokollausgabe die endlos wiederholte Meldung "wait for unlock in delete".
* Ein Sicherheitsfehler ist aufgetreten: Mit dem Header HTTP X-Forward war es möglich, den IP-Filter zu umgehen. Jetzt ist es auch notwendig, die Adresse eines Proxys anzugeben.
* Die Windows-Authentifizierung hat mit Jetty Application Server Version 7.2 funktioniert, aber nicht mit Version 7.0.
* Die Ausnahme "Invalid render state. Page already finished." ist bei Berichten aufgetreten, die nur einen Berichtskopf zeigen und bei denen die Eigenschaft "New Page After" für einen der unterdrückten Abschnitte aktiviert ist.
* Beim Lesen von Spaltenbeschriftungen (Aliasen) eines Befehls ist eine Ausnahme aufgetreten.
* DatabaseBean hat falsche Werte zurückgegeben, wenn die Subbeans null waren.

### i-net Crystal-Clear - Java Viewer
* Es gab ein Problem mit dem Standalone-Berichtsviewer, der sein Cookie nicht korrekt vom Server aktualisierte, was dazu führen konnte, dass die Suche in einem Bericht nicht korrekt funktionierte.
* Beim Kopieren von Text aus einem Bericht im Berichtsviewer wurde am Ende immer ein zusätzlicher Zeilenumbruch eingefügt. Dieser zusätzliche Zeilenumbruch wurde entfernt.
* Der Druckdialog ignoriert den PrintService im PrinterJob, wenn SwingReportView.showPrintDialog(Component, PrinterJob, HashPrintRequestAttributeSet) aufgerufen wurde.

### i-net Designer
* Der SQL-Editor für Abfragen wurde leicht verbessert, kleinere Macken wurden beseitigt.
* Eine NullPointerException ist aufgetreten, wenn die Zahlenkategorie im Eigenschaftseditor für mehrere ausgewählte Feldelemente mit unterschiedlichen Einstellungen im Währungstyp geöffnet wurde.
* Befehle, die auf eine Eingabeaufforderung mit einem Standardwert verweisen, konnten beim Aktualisieren der Spalten des Befehls eine ungültige SQL-Anweisung erzeugen.
* Bei der Bearbeitung eines Berichts, der sich auf einem entfernten Repository befindet, zeigte das Schriftfeld im Diagramm-Dialog nicht die auf dem Server, auf dem sich der Bericht befand, verfügbaren Schriftarten an, sondern die auf dem Client verfügbaren.
* Datenbank-Assistent: "Verbindung aktualisieren" hat die Datenbankobjekte nicht aktualisiert.

### Ad-hoc-Berichterstattung
* Es war nicht möglich, einen gespeicherten Ad Hoc Bericht korrekt zu laden. Es war notwendig, die Ad Hoc Datenansicht erneut auszuwählen.

### Konfigurationsmanager
* Die Änderung der Einstellung "Use Native Fonts" in der i-net Crystal-Clear Konfiguration wirkte sich erst nach einem Neustart des Berichtsservers aus.
* Konfigurierte Rollen der Systemberechtigungen wurden nicht korrekt wiederhergestellt.

[security]

[security:de]
